import { HttpApi } from "@aws-cdk/aws-apigatewayv2-alpha";
import { NodejsFunction } from "aws-cdk-lib/aws-lambda-nodejs";
import { Construct } from "constructs";
import { AstroSiteConstruct } from "./construct";
import { LambdaAstroSiteProps } from "./types";
export declare class LambdaAstroSite extends AstroSiteConstruct {
    private readonly bucket;
    private readonly function;
    private readonly httpApi;
    private readonly distribution;
    readonly bucketArn: string;
    readonly bucketName: string;
    readonly distributionDomainName: string;
    readonly domainName: string;
    constructor(scope: Construct, id: string, props: LambdaAstroSiteProps);
    /**
     *  Returns lambda function
     *
     * @returns
     */
    lambdaFunction(): NodejsFunction;
    /**
     * return http api
     *
     * @returns
     */
    api(): HttpApi;
}
